
#define NUM_BANK 2
#define PATTERNS_ZIPPED_MAX 40000

//dma time commands
#define PATTERN_ZIPPED_COMMAND_DMA_END 0
//+1: a phase by 90deg.
//+2,3: from DMA start 
//+4,5: src neg. offset from here
#define PATTERN_ZIPPED_COMMAND_DMA_COPY_HBURST 1
//+1,2: time to appear
//+2,3: pattern to appear
#define PATTERN_ZIPPED_COMMAND_DMA_LSET_LONG 2
//+0: time to appear + START
//+1,2: pattern to appear
#define PATTERN_ZIPPED_COMMAND_DMA_LSET_START 0x10
#define PATTERN_ZIPPED_COMMAND_DMA_LSET_END 0xffu

//off-dma time commands
#define PATTERN_ZIPPED_COMMAND_END 0
//+1,2 : TimerL
#define PATTERN_ZIPPED_COMMAND_WAIT 1
//+1,2 : TimerL
//+3,4: LSW of TimerU
#define PATTERN_ZIPPED_COMMAND_WAIT_LONG 2
//+1,2 : TimerL
//+3,4: MSW of TimerU
//+5,6: LSW of TimerU
#define PATTERN_ZIPPED_COMMAND_WAIT_LONG_LONG 3
//+1: byte
#define PATTERN_ZIPPED_COMMAND_AUX1 4
//+1: byte
#define PATTERN_ZIPPED_COMMAND_AUX3 5
//+1: address
//+2,3: value
#define PATTERN_ZIPPED_COMMAND_AUX2_DA 6
//+1,2: loops
#define PATTERN_ZIPPED_COMMAND_DO 7
#define PATTERN_ZIPPED_COMMAND_LOOP 8
#define PATTERN_ZIPPED_COMMAND_LOOP_INF 9
#define PATTERN_ZIPPED_COMMAND_BREAKPOINT 0xa 
#define PATTERN_ZIPPED_COMMAND_PULSEON 0xb
//+1,2: last pattern
#define PATTERN_ZIPPED_COMMAND_DMA_SET 0xc
//+1,2: size
//+2n: patterns
#define PATTERN_ZIPPED_COMMAND_DMA_HBURST 0xd
//+1 (signed char): QAM1 offset
//+2 (signed char): QAM2 offset
#define PATTERN_ZIPPED_COMMAND_SET_DA_TUNE_OFFSET 0xe
//+1 (signed char): QAM1 level
//+2 (signed char): QAM2 level
#define PATTERN_ZIPPED_COMMAND_SET_DA_TUNE_LEVEL 0xf
//+1 (signed char): QAM1 delay
//+2 (signed char): QAM2 delay
#define PATTERN_ZIPPED_COMMAND_SET_DA_TUNE_DELAY 0x10

#define PATTERN_COMMAND_END 0
//+0 control.word: size of patterns
//+n patterns
#define PATTERN_COMMAND_DMA_SET 1
//+0 control.word: TimerL
//+1 lword: TimerU
#define PATTERN_COMMAND_WAIT 2
//+0 control.byte: address
//+0 control.word: size of bytes
//+n bytes
#define PATTERN_COMMAND_AUX 3
//+0 control.word: count
#define PATTERN_COMMAND_DO 4
#define PATTERN_COMMAND_LOOP 5
#define PATTERN_COMMAND_LOOP_INF 6
#define PATTERN_COMMAND_BREAKPOINT 7
#define PATTERN_COMMAND_PULSEON 8


#define AUXOUT(port) (((volatile unsigned char*)0xc00000)[3-(port)])
 //CS3 //0x800000; //CS2
 
#define DR_PULSE_OE PA.DR.BIT.B18
#define IOR_PULSE_OE PFC.PAIORH.BIT.B18

int CMDWriteAUX (const char *buf, int fd);
int CMDPulseOn (const char *buf, int fd);
int CMDPulseOff (const char *buf, int fd);
int CMDPulseLoad (const char *buf, int fd);
int CMDPulseTestLoad (const char *buf, int fd);
void InitPulser(void);
void processControls(void);

void DMAC2DEI(void)  __attribute__ ((interrupt_handler));
void MTU4TGIA(void)  __attribute__ ((interrupt_handler));
