OUTPUT_FORMAT("coff-sh")
OUTPUT_ARCH(sh)
ENTRY("_start")
MEMORY
{
	resetv(r) : o = 0x00000000, l = 0x00400
	rom(rx)    : o = 0x0000a000, l = 0x06000
	intram(rwx)   : o = 0xfffff000, l = 0x00800
	extram(rwx)   : o = 0x00400000, l = 0x100000
	stack(rw)  : o = 0xfffff800, l = 0x00800
}
SECTIONS 				
{
.resetv : {
	*(.excv)
	} > resetv
.text : {
	*(.text)
	*(.strings)
	*(.rodata) 				
   	 _etext = . ; 
	} > rom
.tors : {
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	___dtors_end = . ;
	}  > rom
.cache : {
	_cache =  . ;
	} > cache
.intram : {
	_intram =  . ;
	} > intram
.data : AT ( ADDR(.tors) + SIZEOF(.tors) ){
	___data = . ;
	*(.data)
	*(.tiny)
	 _edata = .;
	} > extram
.bss : {
	 _bss_start = . ;
	*(.bss)
	*(COMMON)
	 _end = . ;  
	}  > extram
.stack 0xfffffffc : {
	 _stack = . ;
	*(.stack)
	}  > stack
}
