#include "config.h"
#include "support.h"

void set_imask( int imask )
 {
 int srreg;
 
      imask <<= 4;
      imask &= 0x00f0;
      asm(" stc sr,%0 ":"=r"(srreg):);
      srreg &= 0xffffff0f;
      srreg = srreg | imask;
      asm(" ldc %0,sr "::"r"(srreg));
 }

unsigned short makesum(unsigned char *start, unsigned long bytes)
{
  unsigned short sum = 0;

  for(; bytes > 0; bytes--)
    sum += *(start++);
  return sum;
}

int _sleepa(unsigned short step)
{
  CMT.CMSTR.BIT.STR0 = 0;
  CMT0.CMCSR.WORD = 0; // Clock/8
  CMT0.CMCNT = 0; 
  CMT0.CMCOR = step; 
  
  CMT.CMSTR.BIT.STR0 = 1;

  while (!CMT0.CMCSR.BIT.CMF);

  CMT.CMSTR.BIT.STR0 = 0;
  return 0;
}

int sleepinms(unsigned short ms)
{
  unsigned short cnt;

  CMT.CMSTR.BIT.STR0 = 0;
  CMT0.CMCSR.WORD = 0; // Clock/8
  CMT0.CMCNT = 0; 
  CMT0.CMCOR = CLOCK_IN_Hz / 1000 / 8; //1ms
  CMT.CMSTR.BIT.STR0 = 1;
  
  for(cnt = 0; cnt < ms; cnt++)
    {
      while (!CMT0.CMCSR.BIT.CMF);
      CMT0.CMCSR.BIT.CMF = 0;
    }

  CMT.CMSTR.BIT.STR0 = 0;
  return 0;
}
