//#include <fcntl.h>
//#include <unistd.h>
#include <string.h>
#include "config.h"
#include "commands.h"
#include "support.h"
#include "sci.h"
#include "io.h"

int DoCommand (char *buf, int fd);

#define MAX_BUF 64
char __attribute__ ((section(".intram"))) buf[MAX_BUF];
int __attribute__ ((section(".intram"))) buflen;

typedef void (*fp)(void);

#ifdef ROMSTART
extern void start(void);
extern long stack;
#endif //ROMSTART

void Oops(void)  __attribute__ ((interrupt_handler));
void Oops1(void)  __attribute__ ((interrupt_handler));
void Oops4(void)  __attribute__ ((interrupt_handler));
void Oops6(void)  __attribute__ ((interrupt_handler));
void Oops9(void)  __attribute__ ((interrupt_handler));
void Oops10(void)  __attribute__ ((interrupt_handler));

const fp ExceptionVectorTable[] __attribute__ ((section(".excv"))) = {
#ifdef ROMSTART
   start, (fp)&stack, start, (fp)&stack,
#endif //RAMSTART
#ifdef RAMSTART
   NULL, NULL, NULL, NULL,
#endif //RAMSTART
   Oops4, Oops1, Oops6, Oops1,
   Oops9, Oops10, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1,
   Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1,
   Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1,
   Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1,
   Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1,
   Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1,
   Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1, Oops1,

   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   DMAC2DEI, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   MTU4TGIA, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,

   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops,
   Oops, Oops, Oops, Oops, Oops, Oops, Oops, Oops
}; 

const struct
{
  const char *cmd;
  int (*func)(const char *buf, int fd);
  const char *help;
} cmds[] =
  {
    {"d", CMDDump, "dump/d [addr] [bytes]"},
    {"dump", CMDDump, "dump/d [addr] [bytes]"},
    {"g", CMDGoLoc, "goto/g addr"},
    {"goto", CMDGoLoc, "goto/g addr"},
    {"wb", CMDWriteByte, "writebyte/wb addr byte"},
    {"writebyte", CMDWriteByte, "writebyte/wb addr byte"},
    {"ww", CMDWriteWord, "writeword/ww addr word"},
    {"writeword", CMDWriteWord, "writeword/ww addr word"},
    {"sleep", CMDSleep, "sleep msec"},
    {"load", CMDLoad, "load addr bytes sum [start]"},
    {"run", CMDRun, "run addr"},
    {"setbaudrate", CMDSetBaudRate, "setbaudrate rate stop"},
#ifdef RAMSTART
    {"cache", CMDCacheOn, "cache"},
#endif //RAMSTART
    {"reset", CMDReset, "reset"},
    {"memtest", CMDMemtest, "memtest start bytes"},
    {"help", CMDHelp, "help"},
    {"aux", CMDWriteAUX, "aux port data"},
    {"pon", CMDPulseOn, "pon"},
    {"poff", CMDPulseOff, "poff/!"},
    {"pload", CMDPulseLoad, "pload bytes"},
    {"ptestload", CMDPulseTestLoad, "ptestload"},
    {0, 0, 0}
  };

int initSCI(void)
{
  PFC.PACRL2.BIT.PA4MD = 1; //TXD1
  PFC.PACRL2.BIT.PA3MD = 1; //RXD1
  
  InitSCI1(0, 0, 1, DEF_BAUDRATE/100);
  return open(DEV_SCI1, 0);
}  

int main(void)
{
  int fd;
  unsigned long VBR;
  
  VBR = (unsigned long)ExceptionVectorTable;
  asm(" ldc %0,vbr "::"r"(VBR));
  
  PFC.PACRH.BIT.PA23MD = 1; //WRHH
  PFC.PACRH.BIT.PA22MD = 1; //WRHL
  PFC.PACRL1.BIT.PA14MD = 1; //RD
  PFC.PACRL1.BIT.PA13MD = 1; //WRH
  PFC.PACRL1.BIT.PA12MD = 1; //WRL
  PFC.PACRL1.BIT.PA11MD = 1; //CS1
  PFC.PACRL1.BIT.PA10MD = 1; //CS0
  
  PFC.PBCR1.BIT.PB9MD = 2; //A21
  PFC.PBCR1.BIT.PB8MD = 2; //A20
  PFC.PBCR2.BIT.PB7MD = 2; //A19
  PFC.PBCR2.BIT.PB6MD = 2; //A18
  PFC.PBCR2.BIT.PB1MD = 1; //A17
  PFC.PBCR2.BIT.PB0MD = 1; //A16
  
  PFC.PCCR.WORD = 0xffff; //A0-15
  
  PFC.PDCRH1.WORD = 0x5555; //D24-31

  PFC.PDCRH2.WORD = 0x5555; //D16-23
    
  PFC.PDCRL.WORD = 0xffff; //D0-15
  
  BSC.BCR1.BIT.A1LG = 1; //long access in CS1
  BSC.BCR2.BIT.IW1 = 0; //no idle cycle in CS1
  BSC.BCR2.BIT.CW1 = 0; //no idle cycle in CS1
  BSC.BCR2.BIT.SW1 = 0; //no cs assert in CS1
  
  BSC.WCR1.BIT.W1 = 0; //no wait
  
  locaddr = 0;
  
//  fd = initGPIB(29);
//  if(fd > 0) {
//	doGPIB(fd);
//  }
  fd = initSCI();
  if(fd > 0) {
	fdprintf(fd, "SH2 monitor" NEWLINE);
	fdprintf(fd, "ver 1.2" NEWLINE);
	InitPulser();
        for(;;) doConsole(fd);
  }  
  return 0;
}
int doConsole (int fd)
{
  char s;
 char echo_on = 1;

  buf[0] = 0;
  buflen = 0;

  for(;;)
    {
      if(read(fd, &s, 1) <= 0) return -1;
      if(s == '$') {echo_on = 0; continue;}
      if(s == '!') {return CMDPulseOff(buf, fd); }
      if((s == '\n') || (s == '\r'))
        	{
        	  if(echo_on) fdprintf(fd, NEWLINE);
               	  buf[buflen] = 0;
        	  if(buflen == 0) return -1;
        	  return doCommand(buf, fd);
        	}

      if(echo_on) write(fd, &s, 1);
      buf[buflen] = s;
      buflen++;
      if(buflen >= MAX_BUF) return -1;
    }
}

int doCommand (char *buf, int fd)
{
  int i, ret, len;

  for(i = 0;; i++)
    {
      if(!cmds[i].func)
        	{
        	  fdprintf(fd, "UNKNOWN COMMAND: %s" NEWLINE, buf);
        	  return -1;
        	}
      len = strlen(cmds[i].cmd);
      if((!strncmp(buf, cmds[i].cmd, len)) &&
	 ((buf[len] == ' ') || (buf[len] == '\0')))
        	{
        	  ret = (cmds[i].func)(buf + len, fd);
        	  if(ret != 0)
        	    fdprintf(fd, "SYNTAX ERROR:%d" NEWLINE, ret);
        	  return ret;
        	}
    }
	  
}

int CMDHelp (const char *buf, int fd)
{
int i;
  for(i = 0;; i++)
    {
      if(!cmds[i].func)
	{
	  return 0;
	}
      fdprintf(fd, "%s" NEWLINE, cmds[i].help);
    }
    return 0;
}

//#pragma interrupt
void Oops(void)
{
int fd;
   fd = initSCI();
   fdprintf(fd, "Oops: Unhandled Exception" NEWLINE);
   CMDReset(NULL, 0);
}
//#pragma interrupt
void Oops1(void)
{
int fd;
   fd = initSCI();
   fdprintf(fd, "Oops: Exception, System Error" NEWLINE);
   CMDReset(NULL, 0);
}
//#pragma interrupt
void Oops4(void)
{
int fd;
   fd = initSCI();
   fdprintf(fd, "Oops: Exception, General Illegal" NEWLINE);
   CMDReset(NULL, 0);
}
//#pragma interrupt
void Oops6(void)
{
int fd;
   fd = initSCI();
   fdprintf(fd, "Oops: Exception, Slotting Illegal" NEWLINE);
   CMDReset(NULL, 0);
}
//#pragma interrupt
void Oops9(void)
{
int fd;
   fd = initSCI();
   fdprintf(fd, "Oops: Exception, Address Illegal" NEWLINE);
   CMDReset(NULL, 0);
}
//#pragma interrupt
void Oops10(void)
{
int fd;
   fd = initSCI();
   fdprintf(fd, "Oops: Exception, DTC/DMAC Error" NEWLINE);
   CMDReset(NULL, 0);
}
